{%- from "nova/map.jinja" import controller with context %}

{%- if controller.get('db_purge', {}).get('enabled', False) %}

{%- set cmd_args = [] %}
{%- set api_cmd_args = [] %}
{%- if controller.db_purge.max_rows is defined %}
{%-   do cmd_args.append('--max_rows') %}
{%-   do cmd_args.append(controller.db_purge.max_rows|string) %}
{%- endif %}
{%- if controller.db_purge.get('verbose', True) %}
{%-   do cmd_args.append('--verbose') %}
{%- endif %}
{%- if controller.db_purge.get('all', True) %}
{%-   do cmd_args.append('--until-complete') %}
{%- endif %}
nova_db_clean:
  cmd.run:
  - name: "nova-manage db archive_deleted_rows {{ cmd_args|join(' ') }} || true"
  - runas: 'nova'
  {%- if grains.get('noservices') or controller.get('role', 'primary') == 'secondary' %}
  - onlyif: /bin/false
  {%- endif %}

{%- if controller.version is defined and controller.version[0] in ['r','s','t','u','v','w','x','y','z'] %}
{%-   if controller.db_purge.days is defined %}
{%-     do api_cmd_args.append('--before') %}
{%      set prior_to = salt.cmd.run('date -d "' + controller.db_purge.days|string + ' days ago" +%d.%m.%Y') %}
{%-     do api_cmd_args.append(prior_to) %}
{%-   else %}
{%-     do api_cmd_args.append('--all') %}
{%-   endif %}
{%-   if controller.db_purge.get('verbose', True) %}
{%-     do api_cmd_args.append('--verbose') %}
{%-   endif %}
{%-   if controller.db_purge.get('all_cells', True) %}
{%-     do cmd_args.append('--all-cells') %}
{%-   endif %}
nova_api_db_clean:
  cmd.run:
  - name: "nova-manage db purge {{ api_cmd_args|join(' ') }}"
  - runas: 'nova'
  {%- if grains.get('noservices') or controller.get('role', 'primary') == 'secondary' %}
  - onlyif: /bin/false
  {%- endif %}
{%- endif %}

{%- endif %}
